// TSSSF Case
card_width=63;
card_height=88;
card_thickness_ship=28; //measured: 27.5
card_thickness_goal=23; //measured: 22.5
card_thickness_pony=23; //measured: 22.5
card_clearence=0.5; //per-side

halfcut_ofst=0.3; //Offset for diagonal cut, y-axis, one side
cut_angle=35; //diagonal cut, angle
cut_limit_height=32; //only cut until this height. Should be larger than highest card_thickness_* but lower than box_height

card_base_clearence=0.3; //Card base, per-side inner offset

box_height=36;
box_width=202;
box_depth=93;


card_spacing=67; //x-axis

perimeter_width=2; //width of perimeter
perimeter_clearence=0.3; //gap, from actual wall, per-side
perimeter_gap=0.4; //perimeter's diagonal cut gap, y-axis, per-side
perimater_cut_angle=70;

EPS=0.1;

svg_scale=0.4;
icon_depth=1.0;

finger_hole_yoff=35;
finger_hole_angle=60;
finger_hole_width=30;


sidecap_width=20;
sidecap_thickness=3;
sidecap_gap_y=0.4; //one side
sidecap_gap_z=0.0; //one side
sidecap_endstop_width=3;
sidecap_endstop_size=20;
sidecap_post_width=5;
sidecap_post_gap_thickness=27;
sidecap_post_gap_width=3;
sidecap_post_head_width=5;
sidecap_post_head_thickness=38;
sidecap_post_head_fakebevel_ofst=46;

stickerhole_w=71;
stickerhole_h=21;
stickerhole_depth=0.5;
stickerhole_ofst_x=40;
stickerhole_ofst_z=0;

// The Cap
translate([150,0,0]){
    union(){
        intersection(){
            union(){
                difference(){
                    cube([200,200,200],center=true); //Filler
                    // Hole
                    cube([sidecap_width+EPS,
                        box_depth+perimeter_width*2+sidecap_gap_y*2,
                        box_height+sidecap_gap_z*2],center=true);
                }
                // Corner endstops
                for (ofst=[[-1,-1],[+1,-1],[+1,+1],[-1,+1]]){
                    translate([sidecap_width/2,
                            (box_depth/2+perimeter_width+sidecap_gap_y)*ofst[0],
                            (box_height/2+sidecap_gap_z)*ofst[1]])
                        rotate([45,0,0])
                            cube([sidecap_endstop_width*2,sidecap_endstop_size,sidecap_endstop_size],center=true);
                }
            }
            // Cut
            cube([sidecap_width,
                box_depth+perimeter_width*2+sidecap_gap_y*2+sidecap_thickness*2,
                box_height+sidecap_gap_z*2+sidecap_thickness*2],center=true);
        }
        // The Post
        for (i=[-1,+1]){
            scale([1,i,1])
                translate([sidecap_width/2,box_depth/2+perimeter_width+sidecap_gap_y+sidecap_thickness,0])
                    intersection(){
                        union(){
                            // The Gap
                            translate([-sidecap_post_width/2,sidecap_post_gap_width/2,0]) 
                                cube([sidecap_post_width,sidecap_post_gap_width+EPS,sidecap_post_gap_thickness],center=true);
                            // The Head
                            translate([-sidecap_post_width/2,sidecap_post_gap_width+sidecap_post_head_width/2,0]) 
                                cube([sidecap_post_width,sidecap_post_head_width,sidecap_post_head_thickness],center=true);
                        }
                        translate([0,-sidecap_post_head_fakebevel_ofst,0])
                            rotate([45,0,0])
                                cube([100,100,100],center=true);
                    }
       }
    }
    
}

// The Holder
union(){
    difference(){
        union(){
            // Base box mesh
            difference(){
                cube([box_width,box_depth,box_height],center=true);
                
                // Half-cut
                intersection(){
                    union(){
                        // Diagonal
                        translate([0,halfcut_ofst,0])
                            rotate([cut_angle,0,0])
                                translate([0,0,50])
                                    cube([300,200,100],center=true);
                        // Cut the base (other side)
                        translate([0,0,cut_limit_height/2+50])
                            cube([box_width+EPS,box_depth+EPS,100],center=true);
                    }
                    // Leave the base
                    translate([0,0,50])
                        cube([box_width+EPS,box_depth+EPS,cut_limit_height+100],center=true);
                }
            }
            // Cards base
            intersection(){
                difference(){
                    union(){
                        translate([-card_spacing,0,-card_thickness_pony/2-50])
                            cube([
                                card_width+card_clearence*2-card_base_clearence*2,
                                card_height+card_clearence*2-card_base_clearence*2,
                                100],center=true);
                        
                        translate([0,0,-card_thickness_ship/2-50])
                            cube([
                                card_width+card_clearence*2-card_base_clearence*2,
                                card_height+card_clearence*2-card_base_clearence*2,
                                100],center=true);
                        
                        translate([+card_spacing,0,-card_thickness_goal/2-50])
                            cube([
                                card_width+card_clearence*2-card_base_clearence*2,
                                card_height+card_clearence*2-card_base_clearence*2,
                                100],center=true);
                    }
                    // Finger Hole
                    union(){
                        translate([-card_spacing,-finger_hole_yoff,-card_thickness_pony/2])
                            rotate([-finger_hole_angle,0,0])
                                translate([0,-50,0])
                                    cube([finger_hole_width,100,100],center=true);
                        translate([0,-finger_hole_yoff,-card_thickness_ship/2])
                            rotate([-finger_hole_angle,0,0])
                                translate([0,-50,0])
                                    cube([finger_hole_width,100,100],center=true);
                        translate([+card_spacing,-finger_hole_yoff,-card_thickness_goal/2])
                            rotate([-finger_hole_angle,0,0])
                                translate([0,-50,0])
                                    cube([finger_hole_width,100,100],center=true);
                    }
                }
                cube([box_width-EPS,box_depth-EPS,box_height-EPS],center=true);
            }
        }
        
        
        // Cutters
        union(){
            // Cards cutter
            translate([-card_spacing,-50,50])
                cube([
                    card_width+card_clearence*2,
                    card_height+card_clearence*2+100,
                    card_thickness_pony+100+EPS],center=true);
                
            translate([-card_spacing,0,-card_thickness_pony/2-icon_depth])
                linear_extrude(height=10)
                    scale([svg_scale,svg_scale,svg_scale])
                        import("Icons_rev4.svg",center=true,dpi=300,layer="PONY");
            
            translate([0,-50,50])
                cube([
                    card_width+card_clearence*2,
                    card_height+card_clearence*2+100,
                    card_thickness_ship+100+EPS],center=true);
                   
            translate([0,0,-card_thickness_ship/2-icon_depth])
                linear_extrude(height=10)
                    scale([svg_scale,svg_scale,svg_scale])
                        import("Icons_rev4.svg",center=true,dpi=300,layer="SHIP");
            
            translate([+card_spacing,-50,50])
                cube([
                    card_width+card_clearence*2,
                    card_height+card_clearence*2+100,
                    card_thickness_goal+100+EPS],center=true);
                    
            translate([+card_spacing,0,-card_thickness_goal/2-icon_depth])
                linear_extrude(height=10)
                    scale([svg_scale,svg_scale,svg_scale])
                        import("Icons_rev4.svg",center=true,dpi=300,layer="GOAL");
            
        }
    }
    
    
    
    // Outer Perimeter
    difference(){
        difference(){
            // Base volume
            cube([box_width+perimeter_width*2
                 ,box_depth+perimeter_width*2,
                 box_height],center=true);
            union(){
                // Box bolume
                cube([box_width,box_depth,box_height+EPS],center=true);  
                // Clearence for the other box
                translate([0,0,50+cut_limit_height/2])
                    cube([box_width+perimeter_clearence*2,box_depth+perimeter_clearence*2,100],center=true);
                // Copy of base diagonal cut
                translate([0,halfcut_ofst,0])
                    rotate([cut_angle,0,0])
                        translate([0,0,50])
                            cube([box_width+perimeter_clearence*2,200,100],center=true);
                
            }
        }
        union(){
        // Diagonal Cut
            translate([0,perimeter_gap,0])
                rotate([perimater_cut_angle,0,0])
                    translate([0,0,50])
                        cube([300,200,100],center=true);
            // Textcard
            translate([stickerhole_ofst_x,box_depth/2+perimeter_width,stickerhole_ofst_z])
               cube([stickerhole_w,stickerhole_depth*2,stickerhole_h],center=true);
        }
    }
}
    
